# -*- coding: utf-8 -*-
"""dernier projet ingé

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/150BhsYTZTJvWmQ9JEEkrxnthyiaiI2bY
"""

pip install influxdb

from http.server import BaseHTTPRequestHandler, HTTPServer
import urllib
import time
from influxdb import InfluxDBClient
import sys
import csv
import pandas as pd 
from datetime import datetime
import plotly.express as px

###########################
#    SCRIPT SETTINGS
###########################
# Set the port where you want the bridge service to run
PORT_NUMBER = 1234
# InfluxDB Server parameters
INLUXDB_SERVER_IP = '82.65.155.71'
INLUXDB_SERVER_PORT = 8086
INFLUXDB_USERNAME = 'eleves'
INFLUXDB_PASSWORD = 'SmarthouseG2Elab'
INFLUXDB_DB_NAME = 'jeedom'
###########################

client = InfluxDBClient(INLUXDB_SERVER_IP, INLUXDB_SERVER_PORT, INFLUXDB_USERNAME, INFLUXDB_PASSWORD, INFLUXDB_DB_NAME,ssl=True, verify_ssl=False)

print(client.get_list_database())

client.switch_database('jeedom')

#### Timestamps in seconds ###########"
timestamp_start= 1626307200 #  1634256000 #1610845200  ## timestamp of the begin of period required (in second use https://www.epochconverter.com/)
timestamp_end= 1642204800  ## timestamp of the end of period required (in second use https://www.epochconverter.com/)

#### Convertion of timestamp to datetime
dt_object_start = datetime.fromtimestamp(timestamp_start)
print(dt_object_start)
dt_object_end = datetime.fromtimestamp(timestamp_end)
print(dt_object_end)

bind_params = {'end_time': str(dt_object_end), 'start_time': str(dt_object_start)}

###Temperature 1 : chambre 3 : 3905   / chambre 2 : 3911  / chambre 1 : 3917
 
#### Preparation of the query
query = 'SELECT "value" FROM "jeedom"."autogen"."3917" WHERE time >= $start_time AND time < $end_time'
## query+Printof result
data_temperature_chambre=client.query(query, bind_params=bind_params)
print(data_temperature_chambre)

# ### Temperature 2 : cuisine 760

# #### Preparation of the query
# query = 'SELECT "value" FROM "jeedom"."autogen"."760" WHERE time >= $start_time AND time < $end_time'
# ## query+Printof result
# data_temperature_cuisine=client.query(query, bind_params=bind_params)

### Temperature 3 : salon 3889

#### Preparation of the query
query = 'SELECT "value" FROM "jeedom"."autogen"."3889" WHERE time >= $start_time AND time < $end_time'
## query+Printof result
data_temperature_salon=client.query(query, bind_params=bind_params)


### Chauffage : 2022
query = 'SELECT "value" FROM "jeedom"."autogen"."2022" WHERE time >= $start_time AND time < $end_time'
## query+Printof result
data_chauffage=client.query(query, bind_params=bind_params)

### temperature exterieure : 1768

#### Preparation of the query

query = 'SELECT "value" FROM "jeedom"."autogen"."1768" WHERE time >= $start_time AND time < $end_time'
## query+Printof result
data_temperature_ext=client.query(query, bind_params=bind_params)

def stringdate_to_datetime(stringdatetime: str): #fonction qui permet de modifier l'écriture dechaque instant (retirer les caractères inutiles)
  if "." in stringdatetime:
    stringdatetime=stringdatetime.split(".")[0]
  else:
    stringdatetime=stringdatetime.split("Z")[0]
  return datetime.fromtimestamp(time.mktime(time.strptime(stringdatetime,'%Y-%m-%dT%H:%M:%S')))



########
### Chauffage
########

exported_data = list(data_chauffage.get_points())
header_list = list(exported_data[0].keys())


### Création d'un CSV

with open("chauffage.csv", "w", newline='') as fp:
    writer = csv.writer(fp, dialect='excel')
    print(header_list[1:])
    value_header = header_list[1]
    offset = sum(c.isalpha() for c in value_header)
    print(offset)
    #header_list[1:] = sorted(header_list[1:], key=lambda x: int(x[offset:]))
    header_list[1:] = ['value']
    # print(header_list)
    writer.writerow(header_list)
    for line in exported_data:
        # print(line)
        writer.writerow([line[kn] for kn in header_list])



### Conversion en dataframe et travail sur les données


df_chauffage = pd.read_csv('chauffage.csv')

df_chauffage["datetime"]=df_chauffage["time"].apply(stringdate_to_datetime)
df_chauffage['datetime']=pd.to_datetime(df_chauffage['datetime'], format ='%Y-%m-%dT%H:%M:%S')

#enetre2.datetimes=pd.to_datetime(fenetre2.iloc[:,0],format='%Y-%m-%dT%H:%M:%S')

hour_list = []
df_chauffage.drop(columns=['time'],inplace = True)

print(df_chauffage.shape)
df_chauffage = df_chauffage.drop_duplicates()

df_chauffage =df_chauffage.set_index("datetime")

print(df_chauffage)
#df_chambre1['datetime']=pd.to_datetime(df_chambre1['datetime'], format =')
### Resample
df_chauffage = df_chauffage.resample('10T').max()

### adding hours
hour_list = []
for dt in df_chauffage.index:
  hour_list.append(dt.hour)
df_chauffage["hours"]=hour_list

print(df_chauffage)
print(df_chauffage.isnull().sum())


### La colonne Val2 est similaire à la colonne value, à l'exception que 

df_chauffage['Val2']=df_chauffage['value']

df_chauffage['Val2']=df_chauffage['Val2'].fillna(0)

### creation d'un compteur (pour détecter la premiere date de chauffage et voir si elle était isolée)

df_chauffage['compteur']=0

for idx in range(1,len(df_chauffage)):
  df_chauffage['compteur'].iloc[idx]= df_chauffage['compteur'].iloc[idx-1] + df_chauffage['Val2'].iloc[idx]


print(df_chauffage)
print(df_chauffage.isnull().sum())


## Chercher la date de la ligne ou le compteur est égale à 1

fig = px.line(df_chauffage, x = df_chauffage.index, y = 'value', title = 'Time series with slider')
fig.update_xaxes(rangeslider_visible = True)
fig.show()

### Temperature extérieure


exported_data = list(data_temperature_ext.get_points())
header_list = list(exported_data[0].keys())


### Création d'un CSV

with open("temperature_ext.csv", "w", newline='') as fp:
    writer = csv.writer(fp, dialect='excel')
    print(header_list[1:])
    value_header = header_list[1]
    offset = sum(c.isalpha() for c in value_header)
    print(offset)
    #header_list[1:] = sorted(header_list[1:], key=lambda x: int(x[offset:]))
    header_list[1:] = ['value']
    # print(header_list)
    writer.writerow(header_list)
    for line in exported_data:
        # print(line)
        writer.writerow([line[kn] for kn in header_list])


df_temperature_ext = pd.read_csv('temperature_ext.csv')

df_temperature_ext["datetime"]=df_temperature_ext["time"].apply(stringdate_to_datetime)
df_temperature_ext['datetime']=pd.to_datetime(df_temperature_ext['datetime'], format ='%Y-%m-%dT%H:%M:%S')

#enetre2.datetimes=pd.to_datetime(fenetre2.iloc[:,0],format='%Y-%m-%dT%H:%M:%S')

hour_list = []
df_temperature_ext.drop(columns=['time'],inplace = True)

print(df_temperature_ext.shape)
df_temperature_ext = df_temperature_ext.drop_duplicates()

df_temperature_ext=df_temperature_ext.set_index("datetime")

print(df_temperature_ext)
#df_chambre1['datetime']=pd.to_datetime(df_chambre1['datetime'], format =')
### Resample
df_temperature_ext=df_temperature_ext.resample('60T').mean()

### corriger les valeur Nan, utiliser la température de la demi heure précedente 

df_temperature_ext['Tcorrige']=df_temperature_ext['value']

Nan_count = 0
test_nan = df_temperature_ext["Tcorrige"].isna()

print(test_nan)
for idx in range(1,len(df_temperature_ext)-1):
  if test_nan.iloc[idx]:
    Nan_count+=1
    df_temperature_ext["Tcorrige"].iloc[idx]=df_temperature_ext["Tcorrige"].iloc[idx-1]


### Calculer la température moyenne journalière des 24 dernières heures


df_temperature_ext['Tmean'] = 0

time_inertia_temperature = 24

for idx in range(len(df_temperature_ext)):
  if idx < time_inertia_temperature :
    sum_temp = 0
    for i in range(0,time_inertia_temperature) :
      sum_temp+=df_temperature_ext["Tcorrige"].iloc[i]
    df_temperature_ext["Tmean"].iloc[idx]=sum_temp/time_inertia_temperature

  else : 
    sum_temp = 0
    for i in range(1,time_inertia_temperature+1):
      sum_temp += df_temperature_ext["Tcorrige"].iloc[idx-i]
    df_temperature_ext["Tmean"].iloc[idx]=sum_temp/time_inertia_temperature



# XXXXXXXXXXXXXXXXXXXXXX


### adding hours
hour_list = []
for dt in df_temperature_ext.index:
  hour_list.append(dt.hour)
df_temperature_ext["hours"]=hour_list

print(df_temperature_ext)
print(df_temperature_ext.isnull().sum())


###graph temperature

fig = px.line(df_temperature_ext, x = df_temperature_ext.index, y = 'Tmean', title = 'Evolution de la temperature exterieure moyenne')
fig.update_xaxes(rangeslider_visible = True)

fig.add_scatter(x = df_temperature_ext.index, y = df_temperature_ext['Tcorrige'], name='Temperature reelle')
fig.show()

### CHAMBRE 1
################


### Chambre 1 ###
exported_data = list(data_temperature_chambre.get_points())
header_list = list(exported_data[0].keys())


with open("chambre_temp.csv", "w", newline='') as fp:
    writer = csv.writer(fp, dialect='excel')
    print(header_list[1:])
    value_header = header_list[1]
    offset = sum(c.isalpha() for c in value_header)
    print(offset)
    #header_list[1:] = sorted(header_list[1:], key=lambda x: int(x[offset:]))
    header_list[1:] = ['value']
    # print(header_list)
    writer.writerow(header_list)
    for line in exported_data:
        # print(line)
        writer.writerow([line[kn] for kn in header_list])


df_chambre1 = pd.read_csv('chambre_temp.csv')

df_chambre1["datetime"]=df_chambre1["time"].apply(stringdate_to_datetime)
df_chambre1['datetime']=pd.to_datetime(df_chambre1['datetime'], format ='%Y-%m-%dT%H:%M:%S')

#enetre2.datetimes=pd.to_datetime(fenetre2.iloc[:,0],format='%Y-%m-%dT%H:%M:%S')

hour_list = []
df_chambre1.drop(columns=['time'],inplace = True)

print(df_chambre1.shape)
df_chambre1 = df_chambre1.drop_duplicates()

df_chambre1=df_chambre1.set_index("datetime")

print(df_chambre1)
#df_chambre1['datetime']=pd.to_datetime(df_chambre1['datetime'], format =')
### Resample
df_chambre1=df_chambre1.resample('60T').mean()




df_chambre1['Tcorrige']=df_chambre1['value']

Nan_count = 0
test_nan = df_chambre1["Tcorrige"].isna()

print(test_nan)
for idx in range(1,len(df_chambre1)-1):
  if test_nan.iloc[idx]:
    Nan_count+=1
    df_chambre1["Tcorrige"].iloc[idx]=df_chambre1["Tcorrige"].iloc[idx-1]



### adding hours
hour_list = []
for dt in df_chambre1.index:
  hour_list.append(dt.hour)
df_chambre1["hours"]=hour_list

print(df_chambre1)
print(df_chambre1.isnull().sum())

########
### SALON 
########



### Salon ###

exported_data = list(data_temperature_salon.get_points())
header_list = list(exported_data[0].keys())

with open("salon_temp.csv", "w", newline='') as fp:
    writer = csv.writer(fp, dialect='excel')
    print(header_list[1:])
    value_header = header_list[1]
    offset = sum(c.isalpha() for c in value_header)
    print(offset)
    #header_list[1:] = sorted(header_list[1:], key=lambda x: int(x[offset:]))
    header_list[1:] = ['value']
    # print(header_list)
    writer.writerow(header_list)
    for line in exported_data:
        # print(line)
        writer.writerow([line[kn] for kn in header_list])


df_salon = pd.read_csv('salon_temp.csv')

df_salon["datetime"]=df_salon["time"].apply(stringdate_to_datetime)
df_salon['datetime']=pd.to_datetime(df_salon['datetime'], format ='%Y-%m-%dT%H:%M:%S')

#enetre2.datetimes=pd.to_datetime(fenetre2.iloc[:,0],format='%Y-%m-%dT%H:%M:%S')

hour_list = []
df_salon.drop(columns=['time'],inplace = True)

print(df_salon.shape)
df_salon = df_salon.drop_duplicates()

df_salon=df_salon.set_index("datetime")

print(df_salon)
#df_chambre1['datetime']=pd.to_datetime(df_chambre1['datetime'], format =')
### Resample
df_salon=df_salon.resample('60T').mean()



df_salon['Tcorrige']=df_salon['value']

Nan_count = 0
test_nan = df_salon["Tcorrige"].isna()

print(test_nan)
for idx in range(1,len(df_salon)-1):
  if test_nan.iloc[idx]:
    Nan_count+=1
    df_salon["Tcorrige"].iloc[idx]=df_salon["Tcorrige"].iloc[idx-1]


### adding hours
hour_list = []
for dt in df_salon.index:
  hour_list.append(dt.hour)
df_salon["hours"]=hour_list

print(df_salon)
print(df_salon.isnull().sum())

### Fusionner la temperature exterieure moyenne, la temperature de la chambre et la temperature du salon

###graph temperature

fig = px.line(df_chambre1, x = df_chambre1.index, y = 'Tcorrige', title = 'temperature chambre')
#fig = px.line(df_temperature_ext, x = df_temperature_ext.index, y = 'Tmean', title = 'Evolution de la temperature exterieure moyenne')
fig.update_xaxes(rangeslider_visible = True)

#fig.add_scatter(x = df_chambre1.index, y = df_chambre1['Tcorrige'], name='Temperature chambre')
fig.add_scatter(x = df_salon.index, y = df_salon['Tcorrige'], name='Temperature salon')

fig.show()

#Compter le nombre d'heure ou les temperatures intérieures sont supérieures à la plage

date_debut_chauffage = df_chauffage.index[0]
print(data_debut_chauffage)
 

### Plages de temperature de l'ADEME

# Chambre
max_chambre = 19.5
min_chambre = 17

# Salon
max_salon = 21
min_salon = 19

# Chambre
df_chambre_hiver = df_chambre1[df_chambre1.index >= date_debut_chauffage]

df_chambre_hiver['ecart_degre_limite_sup'] = 0
df_chambre_hiver['depassement_limite_sup'] = 0

df_chambre_hiver['ecart_degre_limite_inf'] = 0
df_chambre_hiver['depassement_limite_inf'] = 0

for idx in range(len(df_chambre_hiver)):
  if df_chambre_hiver['Tcorrige'].iloc[idx]>max_chambre:
    df_chambre_hiver['depassement_limite_sup'].iloc[idx] = 1
    df_chambre_hiver['ecart_degre_limite_sup'].iloc[idx]  =  df_chambre_hiver['Tcorrige'].iloc[idx]-max_chambre
  
  if df_chambre_hiver['Tcorrige'].iloc[idx]<min_chambre:
    df_chambre_hiver['depassement_limite_inf'].iloc[idx] = 1
    df_chambre_hiver['ecart_degre_limite_inf'].iloc[idx]  =  df_chambre_hiver['Tcorrige'].iloc[idx]-min_chambre


print(df_chambre_hiver)



print("### Salon")

#Salon 
df_salon_hiver = df_salon[df_salon.index >= date_debut_chauffage]


df_salon_hiver['ecart_degre_limite_sup'] = 0
df_salon_hiver['depassement_limite_sup'] = 0

df_salon_hiver['ecart_degre_limite_inf'] = 0
df_salon_hiver['depassement_limite_inf'] = 0

for idx in range(len(df_salon_hiver)):
  if df_salon_hiver['Tcorrige'].iloc[idx]>max_salon:
    df_salon_hiver['depassement_limite_sup'].iloc[idx] = 1
    df_salon_hiver['ecart_degre_limite_sup'].iloc[idx]  =  df_salon_hiver['Tcorrige'].iloc[idx]-max_salon
  
  if df_salon_hiver['Tcorrige'].iloc[idx]<min_salon:
    df_salon_hiver['depassement_limite_inf'].iloc[idx] = 1
    df_salon_hiver['ecart_degre_limite_inf'].iloc[idx]  =  df_salon_hiver['Tcorrige'].iloc[idx]-min_salon


print(df_salon_hiver)
  
print("################  BILAN Cas surchauffe ##################### ")
print("### Chambre ")
print("nombre d'heures ou la temperature de la chambre est supérieure à la limite de l'ADEME :", df_chambre_hiver['depassement_limite_sup'].sum()) 
print("Ce qui represente : ", df_chambre_hiver['depassement_limite_sup'].sum()/len(df_chambre_hiver)*100)


print("### Salon ")
print("nombre d'heures ou la temperature du salon est supérieure à la limite de l'ADEME :", df_salon_hiver['depassement_limite_sup'].sum()) 
print("Ce qui represente : ", df_salon_hiver['depassement_limite_sup'].sum()/len(df_salon_hiver)*100)



print("################  BILAN Cas souschauffe ##################### ")
print("### Chambre ")
print("nombre d'heures ou la temperature de la chambre est inférieure à la limite de l'ADEME :", df_chambre_hiver['depassement_limite_inf'].sum()) 
print("Ce qui represente : ", df_chambre_hiver['depassement_limite_inf'].sum()/len(df_chambre_hiver)*100)


print("### Salon ")
print("nombre d'heures ou la temperature du salon est inférieure à la limite de l'ADEME :", df_salon_hiver['depassement_limite_inf'].sum()) 
print("Ce qui represente : ", df_salon_hiver['depassement_limite_inf'].sum()/len(df_salon_hiver)*100)

### Repartition statistique de la temperature des pièces en période de chauffage

print("temperature moyenne de la chambre en période de chauffage : ",df_chambre_hiver['Tcorrige'].mean())
print("temperature moyenne du salon en période de chauffage :",df_salon_hiver['Tcorrige'].mean())





import pylab
import matplotlib.pyplot as plt

BoxName = ['chambre','salon']

data = [df_chambre_hiver['Tcorrige'],df_salon_hiver['Tcorrige']]

plt.boxplot(data)

plt.ylim(16,25)

plt.ylabel('Température °C')

pylab.xticks([1,2], BoxName)


plt.show()

df_chambre_hiver[df_chambre_hiver['hours']==1]['Tcorrige']

hours = [t for t in range(24)]

liste_temperature_chambre_horaire=[]

BoxName = []
for h in hours :
  liste_temperature_chambre_horaire.append(df_chambre_hiver[df_chambre_hiver['hours']==h]['Tcorrige'])

plt.boxplot(liste_temperature_chambre_horaire)

plt.ylim(17,23.5)

plt.ylabel('Température chambre °C')
plt.xlabel('Heures')


plt.show()

hours = [t for t in range(24)]

liste_temperature_salon_horaire=[]

BoxName = []
for h in hours :
  liste_temperature_salon_horaire.append(df_salon_hiver[df_salon_hiver['hours']==h]['Tcorrige'])

plt.boxplot(liste_temperature_salon_horaire)

plt.ylim(18,23)

plt.ylabel('Température salon °C')
plt.xlabel('Heures')

plt.show()

# ####INFLUXDB TO 
# client = InfluxDBClient(INLUXDB_SERVER_IP, INLUXDB_SERVER_PORT, INFLUXDB_USERNAME, INFLUXDB_PASSWORD, INFLUXDB_DB_NAME,ssl=True, verify_ssl=False)

# print(client.get_list_database())

# client.switch_database('jeedom')

# datasheet = client.query('SELECT "value" FROM "jeedom"."autogen"."5229" WHERE time > now() - 4d')



# exported_data = list(datasheet.get_points())
# header_list = list(exported_data[0].keys())

# with open("output1.csv", "w", newline='') as fp:
#     writer = csv.writer(fp, dialect='excel')
#     print(header_list[1:])
#     value_header = header_list[1]
#     offset = sum(c.isalpha() for c in value_header)
#     print(offset)
#     #header_list[1:] = sorted(header_list[1:], key=lambda x: int(x[offset:]))
#     header_list[1:] = ['value']
#     # print(header_list)
#     writer.writerow(header_list)
#     for line in exported_data:
#         # print(line)
#         writer.writerow([line[kn] for kn in header_list])